'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.logout = exports.loadAccount = exports.login = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _reactIsomorphicTools = require('react-isomorphic-tools');

var _reactRouterRedux = require('react-router-redux');

var _constants = require('react-isomorphic-tools/constants');

var _qs = require('qs');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var login = function () {
    var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(form, dispatch, props) {
        var _ref2, token, refreshToken, query;

        return _regenerator2.default.wrap(function _callee$(_context) {
            while (1) {
                switch (_context.prev = _context.next) {
                    case 0:
                        _context.next = 2;
                        return (0, _reactIsomorphicTools.fetcher)('/login_check', {
                            params: form,
                            method: 'POST'
                        });

                    case 2:
                        _ref2 = _context.sent;
                        token = _ref2.token;
                        refreshToken = _ref2.refreshToken;

                        _reactIsomorphicTools.Auth.setToken(token);
                        _reactIsomorphicTools.Auth.setRefreshToken(refreshToken);
                        _context.next = 9;
                        return dispatch(loadAccount);

                    case 9:
                        query = (0, _qs.parse)(props.search, { ignoreQueryPrefix: true });

                        dispatch((0, _reactRouterRedux.push)(query.from ? query.from : '/'));

                    case 11:
                    case 'end':
                        return _context.stop();
                }
            }
        }, _callee, undefined);
    }));

    return function login(_x, _x2, _x3) {
        return _ref.apply(this, arguments);
    };
}();

var loadAccount = function () {
    var _ref3 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2(dispatch) {
        return _regenerator2.default.wrap(function _callee2$(_context2) {
            while (1) {
                switch (_context2.prev = _context2.next) {
                    case 0:
                        _context2.t0 = dispatch;
                        _context2.t1 = _constants.AUTH_ACCOUNT_SUCCESS;
                        _context2.next = 4;
                        return (0, _reactIsomorphicTools.fetcher)('/profiles/own');

                    case 4:
                        _context2.t2 = _context2.sent;
                        _context2.t3 = {
                            type: _context2.t1,
                            payload: _context2.t2
                        };
                        (0, _context2.t0)(_context2.t3);

                    case 7:
                    case 'end':
                        return _context2.stop();
                }
            }
        }, _callee2, undefined);
    }));

    return function loadAccount(_x4) {
        return _ref3.apply(this, arguments);
    };
}();

var logout = function logout() {
    return function (dispatch) {
        _reactIsomorphicTools.Auth.logout();
        dispatch({
            type: _constants.AUTH_LOGOUT_SUCCESS
        });
        dispatch((0, _reactRouterRedux.push)('/login'));
    };
};
exports.login = login;
exports.loadAccount = loadAccount;
exports.logout = logout;