'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _utils = require('../../../../utils');

var _lib = require('../../../../lib');

var _reactIsomorphicTools = require('react-isomorphic-tools');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Item = function Item(_ref) {
    var item = _ref.item,
        data = _ref.data;

    var prefix = (0, _lib.getPrefix)();

    if (item.component) return _react2.default.createElement(item.component, (0, _extends3.default)({ data: (0, _utils.showField)(item.name, data) }, item));

    if (item.hasOne && (0, _utils.showField)(item.name, data)) return _react2.default.createElement(
        _reactIsomorphicTools.Link,
        {
            to: { pathname: prefix + '/' + item.hasOne + '/' + (0, _utils.showField)(item.name, data) } },
        'id - ',
        (0, _utils.showField)(item.name, data),
        ' ',
        item.hasOne
    );
    if (item.hasMany && (0, _utils.showField)(item.name, data).length <= 0) return _react2.default.createElement(
        'ul',
        null,
        (0, _utils.showField)(item.name, data).map(function (_ref2, index) {
            var id = _ref2.id;

            return _react2.default.createElement(
                'li',
                { key: index },
                _react2.default.createElement(
                    _reactIsomorphicTools.Link,
                    {
                        to: { pathname: prefix + '/' + item.hasMany + '/' + id } },
                    'ID ',
                    id
                )
            );
        })
    );
    return _react2.default.createElement(
        'div',
        null,
        (0, _utils.showField)(item.name, data)
    );
};

exports.default = Item;