'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ReactAdminConfig = function ReactAdminConfig() {
    var _this = this;

    (0, _classCallCheck3.default)(this, ReactAdminConfig);

    this.setEntities = function (entities) {
        return _this.entities = entities;
    };

    this.getEntities = function () {
        return _this.entities;
    };

    this.getEntity = function (entityName) {
        var entities = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _this.entities;

        var entity = false;
        for (var i in entities) {
            if (entities.hasOwnProperty(i)) {
                var element = entities[i];
                if (element.name == entityName) {
                    entity = element;
                }
                if (element.hasOwnProperty('nestedItems')) {
                    var result = _this.getEntity(entityName, element.nestedItems);
                    if (result) return result;
                }
            }
        }
        return entity;
    };

    this.setPrefix = function (prefix) {
        return _this.prefix = prefix;
    };

    this.getPrefix = function () {
        return _this.prefix;
    };

    this.setWidgets = function (widgets) {
        return _this.widgets = widgets;
    };

    this.getWidgets = function () {
        return _this.widgets;
    };

    this.setFormFields = function (formFields) {
        return _this.formFields = formFields;
    };

    this.getFormFields = function () {
        return _this.formFields;
    };

    this.getHeader = function () {
        return _this.header;
    };

    this.setHeader = function (header) {
        return _this.header = header;
    };

    this.getFilters = function () {
        return _this.filters;
    };

    this.setFilters = function (filters) {
        return _this.filters = filters;
    };

    this.entities = {};
    this.prefix = 'entity';
    this.widgets = {};
    this.formFields = {};
    this.header = 'React Admin';
    this.filters = {};
}

// getters/setters

;

exports.default = ReactAdminConfig;