'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _Layout = require('../components/Layout');

var _Layout2 = _interopRequireDefault(_Layout);

var _List = require('../views/List');

var _List2 = _interopRequireDefault(_List);

var _Show = require('../views/Show');

var _Show2 = _interopRequireDefault(_Show);

var _Create = require('../views/Create');

var _Create2 = _interopRequireDefault(_Create);

var _Edit = require('../views/Edit');

var _Edit2 = _interopRequireDefault(_Edit);

var _actions = require('../actions');

var _lib = require('../lib');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var prefix = (0, _lib.getPrefix)();

exports.default = [{
    component: _Layout2.default,
    routes: [{
        path: prefix + '/:name',
        component: _List2.default,
        preload: _actions.list,
        exact: true,
        strict: true
    }, {
        path: prefix + '/:name/create',
        component: _Create2.default,
        exact: true,
        strict: true
    }, {
        path: prefix + '/:name/:id',
        component: _Show2.default,
        preload: _actions.show,
        exact: true,
        strict: true
    }, {
        path: prefix + '/:name/:id/edit',
        component: _Edit2.default,
        preload: _actions.show,
        exact: true,
        strict: true
    }]
}];